package client;

import client.Animal; 
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;


public class parash {

	public static void main(String[] args) {
		
		int[][] pole;
            char[] chars;
		
		int influence, safety;
		List<int[]> fCoords = new LinkedList<int[]>();
		List<Animal> animals;
                int[][] animalBody;
		int iter = 0;
		String line = new String();
                int[] check = new int[2];
		String str;
		List<Integer> orderOfFellAnimals;
                Animal tempAnimal = new Animal();
		File inFile = null;
		File outFile = null;
		Scanner fileReader = null;
		PrintWriter fileWriter = null;
		
		int rows, columns, numAnimals, animalRows, animalColumns;
		
		try{
			inFile = new File("parash.in");
			outFile = new File("parash.out");
			fileReader = new Scanner(inFile);
			fileWriter = new PrintWriter(outFile);
			
			rows = fileReader.nextInt();
			columns = fileReader.nextInt();
			numAnimals = fileReader.nextInt();
			animals = new ArrayList<Animal>(numAnimals);
			orderOfFellAnimals = new ArrayList<Integer>(numAnimals);
			pole = new int[rows][columns];
			
			for(int e=0; e<numAnimals; e++){
				animals.add(new Animal());
			}
			
			for(int b=0; b<rows; b++){
				for(int h=0; h<columns; h++){
					pole[b][h] = fileReader.nextInt();
				}
			}
			
			for(int j=0; j<numAnimals; j++){
				animalRows = fileReader.nextInt();
				animalColumns = fileReader.nextInt();
				influence = fileReader.nextInt();
				safety = fileReader.nextInt();
				animalBody = new int[animalRows][animalColumns];
				line = fileReader.nextLine();

				for(int e=0; e<animalRows; e++){
					line = fileReader.nextLine();
					//row = Integer.parseInt(line);
					chars = line.toCharArray();
					for(int w=0; w<animalColumns; w++){
						str = Character.toString(chars[w]);
						animalBody[e][w] = Integer.parseInt(str);
						
					}
				}
				
				tempAnimal=animals.get(j);
				tempAnimal.setAnimalBody(animalBody);
				tempAnimal.setInfluence(influence);
				tempAnimal.setSafety(safety);
				tempAnimal.setOrderNum(j);
			}				
			
			if(animals.size() > 0){
				for(iter=0; iter<animals.size(); iter++){
					tempAnimal = animals.get(iter);
					if(checkAnimal(pole, animals.get(iter)) == true){
						check = putAnimal(pole, animals.get(iter));
						if( (check[0] != -1) && (check[1] != -1) ){
							fCoords.add( check );
							orderOfFellAnimals.add(tempAnimal.getOrderNum());
							changeMap(pole, fCoords.get(fCoords.size()-1), animals.get(iter) );
						}
					}
					else{
					}
				}
			}
			else{
			}
			if(fCoords.size()>0){
				fileWriter.println(orderOfFellAnimals.size());
				int s=0;
				int[] coord = new int[2];
				do{
					coord = fCoords.get(s);
					fileWriter.println((orderOfFellAnimals.get(s)+1)+" " + (coord[0]+1) + " " + (coord[1]+1) );
					s++;
				}while(s < orderOfFellAnimals.size());
			}
			
			
		}
		catch(FileNotFoundException fileNotFounEx){
		}
		finally{
			try{
				fileReader.close();
				fileWriter.close();
			}
			catch(Exception ex){
			}
		}
        }

	public static int[] putAnimal(int[][] map, Animal animal){
		int[][] animalBody = animal.getAnimalBody();
		List<Integer> sCoords = new LinkedList<Integer>();
		int[][] allCoordinates;
		int i=0;
		boolean isSafety = false;
		int size=0;
		int[] maxSafetyCoordinate = new int[2];
		int differenceX = map[0].length - animalBody[0].length;
		int differenceY = map.length - animalBody.length;
		allCoordinates = new int[(differenceX+1)*(differenceY+1)][2];

		for(int y=0; y<=differenceY; y++){
			for(int x=0; x<=differenceX; x++){
				allCoordinates[i][0] = y;
				allCoordinates[i][1] = x;
				i++;
				isSafety = check(map, x, y, animal);
				if(isSafety == true){
					sCoords.add( y );
					sCoords.add( x );
				}
			}
		}
		
		if(sCoords.size() != 0){
			size = sCoords.size();
                        maxSafetyCoordinate[0] = sCoords.get(size-2);
			maxSafetyCoordinate[1] = sCoords.get(size-1);
		}
		else{
			maxSafetyCoordinate[0] = -1;
			maxSafetyCoordinate[1] = -1;
		}
		
		
		return maxSafetyCoordinate;
	}
	
	public static boolean check(int[][] map, int x, int y, Animal animal){
		boolean isSafety=false;
		int m=0;
		int k = 0;
		int[][] animalBody = animal.getAnimalBody();
		
		for(int i=y; i<(animalBody.length+y); i++){
			for(int j=x; j<(animalBody[0].length+x); j++){
				if( (animalBody[m][k]==1) && ((map[i][j]*animalBody[m][k]) < animal.getSafety()) ){
					isSafety=false;
					return isSafety;
				}
				k++;
			}
			m++;
			k=0;
		}
		
		isSafety=true;
		return isSafety;
	}
	
	public static void changeMap(int[][] map, int[] fallCoordinate, Animal animal){
		int[][] animalBody = animal.getAnimalBody();
		int[] coordinate = new int[2];
		coordinate = fallCoordinate;
		int m=0, k=0;
		for(int i=coordinate[0]; i<(animalBody.length + coordinate[0]); i++){
			for(int j=coordinate[1]; j<(animalBody[0].length + coordinate[1]); j++){
				if(animalBody[m][k]==1){
					map[i][j] = map[i][j] / animal.getInfluence();		
				}
				k++;
			}
			m++;
			k=0;
		}
	}
	public static boolean checkAnimal(int[][] map, Animal animal){
		boolean isInMap = false;
		int[][] animalBody = animal.getAnimalBody();
		if( (animalBody.length <= map.length) && (animalBody[0].length <= map[0].length) ){
			isInMap = true;
		}
		return isInMap;
	}
}
